//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.UnobservablePropertyTest.UnobservablePropertyTest
{
    
    
    /// <summary>
    /// Class that implements the IUnobservablePropertyTest interface through SiLA2
    /// </summary>
    public partial class UnobservablePropertyTestClient : IUnobservablePropertyTest
    {
        
        private System.Lazy<long> _answerToEverything;
        
        private System.Lazy<long> _secondsSince1970;
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.unobservablepropertytest.v1.UnobservablePropertyTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public UnobservablePropertyTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Returns the answer to the ultimate question of life, the universe, and everything. 42.
        /// </summary>
        public virtual long AnswerToEverything
        {
            get
            {
                return _answerToEverything.Value;
            }
        }
        
        /// <summary>
        /// Returns the unix timestamp: The time in seconds since January 1st of 1970.
        /// </summary>
        public virtual long SecondsSince1970
        {
            get
            {
                return _secondsSince1970.Value;
            }
        }
        
        private long RequestAnswerToEverything()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/UnobservablePropertyTest/v1/Property/AnswerToEverything");
            try
            {
                long response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.IntegerDto>>(_serviceName, "AnswerToEverything", "org.silastandard/test/UnobservablePropertyTest/v1/Property/AnswerToEverything", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private long RequestSecondsSince1970()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/UnobservablePropertyTest/v1/Property/SecondsSince1970");
            try
            {
                long response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.IntegerDto>>(_serviceName, "SecondsSince1970", "org.silastandard/test/UnobservablePropertyTest/v1/Property/SecondsSince1970", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _answerToEverything = new System.Lazy<long>(RequestAnswerToEverything);
            _secondsSince1970 = new System.Lazy<long>(RequestSecondsSince1970);
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Unobservable Property Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class UnobservablePropertyTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/UnobservablePropertyTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IUnobservablePropertyTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new UnobservablePropertyTestClient(channel, executionManager);
        }
    }
}

